package quimufu.colourful_portals.mixin;

import me.jellysquid.mods.sodium.client.render.chunk.compile.buffers.ChunkModelBuilder;
import me.jellysquid.mods.sodium.client.render.chunk.compile.pipeline.FluidRenderer;
import net.minecraft.fluid.FluidState;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.BlockRenderView;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import quimufu.colourful_portals.client.SodiumPortalFluidRenderHandler;

import static quimufu.colourful_portals.ColourfulPortalsMod.PORTAL_FLUID;

@Mixin(FluidRenderer.class)
public class SodiumFluidRendererMixin {

    private final SodiumPortalFluidRenderHandler sodiumPortalFluidRenderHandler = new SodiumPortalFluidRenderHandler();

    @Inject(at = @At("HEAD"), method = "render", cancellable = true, remap = false)
    private void init(BlockRenderView world, FluidState fluidState, BlockPos pos, BlockPos offset, ChunkModelBuilder buffers, CallbackInfoReturnable<Boolean> cir) {
        if (fluidState.isOf(PORTAL_FLUID)) {
            cir.setReturnValue(sodiumPortalFluidRenderHandler.render(world, fluidState, pos, offset, buffers));
            cir.cancel();
        }
    }
}
